﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Configuration;
using System.Xml;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.Page 
{
    #region Congress Event Data definition
    /// <summary>
    /// holds the data of one particular category
    /// </summary>
    public class CongressEvent
    {
        public Int32 Id;
        public Int32 DayIndex;
        public DateTime StartDate;
        public DateTime StartTime;
        public TimeSpan duration;
        public String Room;
        public String Title;
        public String Subtitle;
        public String track;
        public String language;
        public String abstract_text;
        public String description;

        public List<String> Persons;

        public List<String> Links;

        public CongressEvent()
        {
            Persons = new List<String>();
            Links = new List<String>();
        }
    }
    #endregion
    public static List<CongressEvent> Saal1 = new List<CongressEvent>();
    public static List<CongressEvent> Saal2 = new List<CongressEvent>();
    public static List<CongressEvent> Saal3 = new List<CongressEvent>();
    public static List<CongressEvent> Saal4 = new List<CongressEvent>();

    public String RenderValidFilename(CongressEvent lecture)
    {
        return Convert.ToString(lecture.Id) + "-" + lecture.Title.Replace(' ', '_');;
    }

    public CongressEvent CurrentlyRunningHelper(List<CongressEvent> Events)
    {
        // never returns "pause"; always returns a valid CongressEvent (the next if no valid one found that is currently running)
        foreach (CongressEvent event_ in Events)
        {
            if (event_.StartDate.Date.Day == DateTime.Now.Date.Day)
            {
                // 1560 < 1640
                if (event_.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                {
                    // it started already or is over already...
                    if ( (event_.StartTime.TimeOfDay.Ticks+event_.duration.Ticks) > DateTime.Now.TimeOfDay.Ticks)
                    {
                        // it's running
                        return event_;
                    }
                    else
                    {
                        // it's over
                    }
                }
                else
                {

                }
            }
        }
        // when we end up here; we obviously did not found anything; so let's give the requesting user the next upcoming event
        foreach (CongressEvent event_ in Events)
        {
            if (event_.StartDate.Date.Day == DateTime.Now.Date.Day)
            {
                // something found for today
                if (event_.StartTime.TimeOfDay.Ticks > DateTime.Now.TimeOfDay.Ticks)
                {
                    return event_;
                }

            }
        }
        throw (new Exception("nothing found"));
    }

    public CongressEvent WhatsCurrentlyRunningIn(int room)
    {
        if (room == 1)
        {
            return CurrentlyRunningHelper(Saal1);
        }
        else
            if (room == 2)
            {
                return CurrentlyRunningHelper(Saal2);
            }
            else
                if (room == 3)
                {
                    return CurrentlyRunningHelper(Saal3);
                }
                else
                    if (room == 4)
                    {
                        return CurrentlyRunningHelper(Saal4);
                    }
                    else
                        throw(new System.Exception("nothing found"));
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // read the schedule.en.xml file...
        #region Load Conference XML
        XmlTextReader reader = new XmlTextReader(Server.MapPath("~\\schedule.en.xml"));

        CongressEvent currentEvent = new CongressEvent();

        DateTime currentDay = DateTime.Now;
        bool addoneday = false;
        bool raushier = false;

        while (reader.Read())
        {
            switch (reader.NodeType)
            {
                case XmlNodeType.EndElement:
                    switch (reader.Name)
                    {
                        case "conference":
                            raushier = true;
                            break;
                    }
                    break;
            }
            if (raushier) break;
        }


        while (reader.Read())
        {
            switch (reader.NodeType)
            {
                case XmlNodeType.Element: // Der Knoten ist ein Event
                    switch (reader.Name)
                    {
                        #region Nodes
                        case "day":
                            DateTime.TryParse(reader["date"], out currentDay);
                            //currentDay = DateTime.Now.Date;
                            break;
                        case "event":
                            currentEvent = new CongressEvent();
                            currentEvent.Id = Convert.ToInt32(reader["id"]);
                            currentEvent.StartDate = currentDay;
                            break;
                        case "start":
                            reader.Read();
                            DateTime.TryParse(reader.Value, out currentEvent.StartTime);
                            if (currentEvent.StartTime.Hour == 0)
                            {
                                addoneday = true;
                            }
                            break;
                        case "duration":
                            reader.Read();
                            TimeSpan.TryParse(reader.Value, out currentEvent.duration);
                            break;
                        case "room":
                            reader.Read();
                            currentEvent.Room = reader.Value;
                            break;
                        case "title":
                            reader.Read();
                            currentEvent.Title = reader.Value;
                            break;
                        case "subtitle":
                            reader.Read();
                            currentEvent.Subtitle = reader.Value;
                            break;
                        case "track":
                            reader.Read();
                            currentEvent.track = reader.Value;
                            break;
                        case "language":
                            reader.Read();
                            currentEvent.language = reader.Value;
                            break;
                        #endregion
                    }
                    break;
                case XmlNodeType.Text: //Anzeigen des Textes in jedem Element.
                    //Console.WriteLine(reader.Value);
                    break;
                case XmlNodeType.EndElement: //Anzeigen des Endes des Elements.
                    switch (reader.Name)
                    {
                        case "event":
                            if (addoneday)
                            {
                                currentEvent.StartDate = currentEvent.StartDate.AddDays(1);
                                addoneday = false;
                            }
                            if (currentEvent.Room == "Saal 1")
                                Saal1.Add(currentEvent);
                            if (currentEvent.Room == "Saal 2")
                                Saal2.Add(currentEvent);
                            if (currentEvent.Room == "Saal 3")
                                Saal3.Add(currentEvent);
                            if (currentEvent.Room == "Saal 4")
                                Saal4.Add(currentEvent);
                            /*
                            if (currentEvent.StartDate.Ticks >= DateTime.Now.Date.Ticks)
                            {
                                if ((currentEvent.StartTime.TimeOfDay.Ticks + currentEvent.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                                {
                                }
                            }*/
                            //CongressEvents.Add(currentEvent);
                            break;
                    }
                    break;
            }
        }
        #endregion
        Response.Clear();

        String output = "";
        CongressEvent event_;

        try
        {
            if (Request.QueryString["saal"] != null)
            {
                // find room
                switch (Request.QueryString["saal"])
                {
                    case "saal1":
                        event_ = WhatsCurrentlyRunningIn(1);
                        output = event_.Id + "-" + event_.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("ü","ue").Replace("Ü","Ue").Replace("ö","oe").Replace("Ö","Oe").Replace("ä","ae").Replace("Ä","Ae").Replace("ß","ss");
                        Response.Write(output);
                        break;
                    case "saal2":
                        event_ = WhatsCurrentlyRunningIn(2);
                        output = event_.Id + "-" + event_.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("ü", "ue").Replace("Ü", "Ue").Replace("ö", "oe").Replace("Ö", "Oe").Replace("ä", "ae").Replace("Ä", "Ae").Replace("ß", "ss");
                        Response.Write(output);
                        break;
                    case "saal3":
                        event_ = WhatsCurrentlyRunningIn(3);
                        output = event_.Id + "-" + event_.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("ü", "ue").Replace("Ü", "Ue").Replace("ö", "oe").Replace("Ö", "Oe").Replace("ä", "ae").Replace("Ä", "Ae").Replace("ß", "ss");
                        Response.Write(output);
                        break;
                    case "saal4":
                        event_ = WhatsCurrentlyRunningIn(4);
                        output = event_.Id + "-" + event_.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("ü", "ue").Replace("Ü", "Ue").Replace("ö", "oe").Replace("Ö", "Oe").Replace("ä", "ae").Replace("Ä", "Ae").Replace("ß", "ss"); 
                        Response.Write(output);
                        break;
                }
            }
            else
            {
                Response.Write(DateTime.Now.ToLongDateString().Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_') + "_" + DateTime.Now.ToLongTimeString().Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('>', '_').Replace('<', '_').Replace("ü", "ue").Replace("Ü", "Ue").Replace("ö", "oe").Replace("Ö", "Oe").Replace("ä", "ae").Replace("Ä", "Ae").Replace("ß", "ss"));
            }
        }
        catch (Exception)
        {
            Response.Write(DateTime.Now.ToLongDateString().Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_') + "_" + DateTime.Now.ToLongTimeString().Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('>', '_').Replace('<', '_').Replace("ü", "ue").Replace("Ü", "Ue").Replace("ö", "oe").Replace("Ö", "Oe").Replace("ä", "ae").Replace("Ä", "Ae").Replace("ß", "ss"));
        }

    }
}
