using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Xml;
using System.Threading;
using System.Windows.Forms;

namespace _3c3_UpcomingEvents
{
    public partial class comingup : Form
    {
        #region Congress Event Data definition
        /// <summary>
        /// holds the data of one particular category
        /// </summary>
        public class CongressEvent
        {
            public Int32 Id;
            public Int32 DayIndex;
            public DateTime StartDate;
            public DateTime StartTime;
            public TimeSpan duration;
            public String Room;
            public String Title;
            public String Subtitle;
            public String track;
            public String language;
            public String abstract_text;
            public String description;

            public List<String> Persons;

            public List<String> Links;

            public CongressEvent()
            {
                Persons = new List<String>();
                Links = new List<String>();
            }
        }
        #endregion
        public static List<CongressEvent> Saal1 = new List<CongressEvent>();
        public static List<CongressEvent> Saal2 = new List<CongressEvent>();
        public static List<CongressEvent> Saal3 = new List<CongressEvent>();
        public static List<CongressEvent> Saal4 = new List<CongressEvent>();

        Thread render_thread;

        public comingup()
        {
            InitializeComponent();
        }

        private void comingup_Load(object sender, EventArgs e)
        {
            #region Load Conference XML
            XmlTextReader reader = new XmlTextReader("schedule.en.xml");

            CongressEvent currentEvent = new CongressEvent();

            DateTime currentDay = DateTime.Now;
            bool addoneday = false;
            bool raushier = false;

            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.EndElement:
                        switch (reader.Name)
                        {
                            case "conference":
                                raushier = true;
                                break;
                        }
                        break;
                }
                if (raushier) break;
            }

            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.Element: // Der Knoten ist ein Event
                        switch (reader.Name)
                        {
                            #region Nodes
                            case "day":
                                DateTime.TryParse(reader["date"], out currentDay);
                                //currentDay = DateTime.Now.Date;
                                break;
                            case "event":
                                currentEvent = new CongressEvent();
                                currentEvent.Id = Convert.ToInt32(reader["id"]);
                                currentEvent.StartDate = currentDay;
                                break;
                            case "start":
                                reader.Read();
                                DateTime.TryParse(reader.Value, out currentEvent.StartTime);
                                if (currentEvent.StartTime.Hour == 0)
                                {
                                    addoneday = true;
                                }
                                break;
                            case "duration":
                                reader.Read();
                                TimeSpan.TryParse(reader.Value, out currentEvent.duration);
                                break;
                            case "room":
                                reader.Read();
                                currentEvent.Room = reader.Value;
                                break;
                            case "title":
                                reader.Read();
                                currentEvent.Title = reader.Value;
                                break;
                            case "subtitle":
                                reader.Read();
                                currentEvent.Subtitle = reader.Value;
                                break;
                            case "track":
                                reader.Read();
                                currentEvent.track = reader.Value;
                                break;
                            case "language":
                                reader.Read();
                                currentEvent.language = reader.Value;
                                break;
                            #endregion
                        }
                        break;
                    case XmlNodeType.Text: //Anzeigen des Textes in jedem Element.
                        //Console.WriteLine(reader.Value);
                        break;
                    case XmlNodeType.EndElement: //Anzeigen des Endes des Elements.
                        switch (reader.Name)
                        {
                            case "event":
                                currentEvent.Title = currentEvent.StartTime.ToShortTimeString() + " #" + currentEvent.Id + " " + currentEvent.Title;
                                if (addoneday)
                                {
                                    currentEvent.StartDate = currentEvent.StartDate.AddDays(1);
                                    addoneday = false;
                                }
                                if (currentEvent.Room == "Saal 1")
                                    Saal1.Add(currentEvent);
                                if (currentEvent.Room == "Saal 2")
                                    Saal2.Add(currentEvent);
                                if (currentEvent.Room == "Saal 3")
                                    Saal3.Add(currentEvent);
                                if (currentEvent.Room == "Saal 4")
                                    Saal4.Add(currentEvent);
                                /*
                                if (currentEvent.StartDate.Ticks >= DateTime.Now.Date.Ticks)
                                {
                                    if ((currentEvent.StartTime.TimeOfDay.Ticks + currentEvent.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                                    {
                                    }
                                }*/
                                //CongressEvents.Add(currentEvent);
                                break;
                        }
                        break;
                }
            }
            #endregion
            render_thread = new Thread(new ThreadStart(UpdateThread));
            render_thread.Start();
            //UpdateThread();
        }

        #region ThreadSafeism

        #region Saal 1
        delegate void SetTextSaal1Callback(String value);
        delegate void SetTextSaal1Callback2(String value);
        delegate void SetIntSaal1Callback(int value);

        private void SetSaal1ProgressBar(int percentage)
        {
            try
            {
                if (this.Saal1_running_progress.InvokeRequired)
                {
                    SetIntSaal1Callback d = new SetIntSaal1Callback(SetSaal1ProgressBar);
                    this.Invoke(d, new object[] { percentage });
                }
                else
                {
                    this.Saal1_running_progress.Value = percentage;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal1RunningText(String value)
        {
            try
            {
                if (this.Saal1_running.InvokeRequired)
                {
                    SetTextSaal1Callback d = new SetTextSaal1Callback(SetSaal1RunningText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal1_running.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal1UpcomingText(String value)
        {
            try
            {
                if (this.Saal1_upcoming.InvokeRequired)
                {
                    SetTextSaal1Callback2 d = new SetTextSaal1Callback2(SetSaal1UpcomingText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal1_upcoming.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }
        #endregion
        #region Saal 2
        delegate void SetTextSaal2Callback(String value);
        delegate void SetTextSaal2Callback2(String value);
        delegate void SetIntSaal2Callback(int value);

        private void SetSaal2ProgressBar(int percentage)
        {
            try
            {
                if (this.Saal2_running_progress.InvokeRequired)
                {
                    SetIntSaal2Callback d = new SetIntSaal2Callback(SetSaal2ProgressBar);
                    this.Invoke(d, new object[] { percentage });
                }
                else
                {
                    this.Saal2_running_progress.Value = percentage;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal2RunningText(String value)
        {
            try
            {
                if (this.Saal2_running.InvokeRequired)
                {
                    SetTextSaal2Callback d = new SetTextSaal2Callback(SetSaal2RunningText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal2_running.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal2UpcomingText(String value)
        {
            try
            {
                if (this.Saal2_upcoming.InvokeRequired)
                {
                    SetTextSaal2Callback2 d = new SetTextSaal2Callback2(SetSaal2UpcomingText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal2_upcoming.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }
        #endregion
        #region Saal 3
        delegate void SetTextSaal3Callback(String value);
        delegate void SetTextSaal3Callback2(String value);
        delegate void SetIntSaal3Callback(int value);

        private void SetSaal3ProgressBar(int percentage)
        {
            try
            {
                if (this.Saal3_running_progress.InvokeRequired)
                {
                    SetIntSaal3Callback d = new SetIntSaal3Callback(SetSaal3ProgressBar);
                    this.Invoke(d, new object[] { percentage });
                }
                else
                {
                    this.Saal3_running_progress.Value = percentage;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal3RunningText(String value)
        {
            try
            {
                if (this.Saal3_running.InvokeRequired)
                {
                    SetTextSaal3Callback d = new SetTextSaal3Callback(SetSaal3RunningText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal3_running.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal3UpcomingText(String value)
        {
            try
            {
                if (this.Saal3_upcoming.InvokeRequired)
                {
                    SetTextSaal3Callback2 d = new SetTextSaal3Callback2(SetSaal3UpcomingText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal3_upcoming.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }
        #endregion
        #region Saal 4
        delegate void SetTextSaal4Callback(String value);
        delegate void SetTextSaal4Callback2(String value);
        delegate void SetIntSaal4Callback(int value);

        private void SetSaal4ProgressBar(int percentage)
        {
            try
            {
                if (this.Saal4_running_progress.InvokeRequired)
                {
                    SetIntSaal4Callback d = new SetIntSaal4Callback(SetSaal4ProgressBar);
                    this.Invoke(d, new object[] { percentage });
                }
                else
                {
                    this.Saal4_running_progress.Value = percentage;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal4RunningText(String value)
        {
            try
            {
                if (this.Saal4_running.InvokeRequired)
                {
                    SetTextSaal4Callback d = new SetTextSaal4Callback(SetSaal4RunningText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal4_running.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }

        private void SetSaal4UpcomingText(String value)
        {
            try
            {
                if (this.Saal4_upcoming.InvokeRequired)
                {
                    SetTextSaal4Callback2 d = new SetTextSaal4Callback2(SetSaal4UpcomingText);
                    this.Invoke(d, new object[] { value });
                }
                else
                {
                    this.Saal4_upcoming.Text = value;
                }
            }
            catch (Exception e)
            {
            }
        }
        #endregion


        #endregion

        public CongressEvent NextRunningHelper(CongressEvent PreviousEvent)
        {
            if (PreviousEvent == null)
                return null;
            bool return_next_one = false;
            switch (PreviousEvent.Room)
            {
                case "Saal 1":
                    foreach (CongressEvent event_ in Saal1)
                    {
                        if (return_next_one)
                        {
                            return event_;
                        }

                        if (event_.StartDate.Day == PreviousEvent.StartDate.Day)
                        {
                            if (event_.StartTime.Ticks == PreviousEvent.StartTime.Ticks)
                            {
                                // return the next event...
                                return_next_one = true;
                            }
                        }
                    }
                    return null;
                    break;
                case "Saal 2":
                    foreach (CongressEvent event_ in Saal2)
                    {
                        if (return_next_one)
                        {
                            return event_;
                        }

                        if (event_.StartDate.Day == PreviousEvent.StartDate.Day)
                        {
                            if (event_.StartTime.Ticks == PreviousEvent.StartTime.Ticks)
                            {
                                // return the next event...
                                return_next_one = true;
                            }
                        }
                    }
                    return null;
                    break;
                case "Saal 3":
                    foreach (CongressEvent event_ in Saal3)
                    {
                        if (return_next_one)
                        {
                            return event_;
                        }

                        if (event_.StartDate.Day == PreviousEvent.StartDate.Day)
                        {
                            if (event_.StartTime.Ticks == PreviousEvent.StartTime.Ticks)
                            {
                                // return the next event...
                                return_next_one = true;
                            }
                        }
                    }
                    return null;
                    break;
                case "Saal 4":
                    foreach (CongressEvent event_ in Saal4)
                    {
                        if (return_next_one)
                        {
                            return event_;
                        }

                        if (event_.StartDate.Day == PreviousEvent.StartDate.Day)
                        {
                            if (event_.StartTime.Ticks == PreviousEvent.StartTime.Ticks)
                            {
                                // return the next event...
                                return_next_one = true;
                            }
                        }
                    }
                    return null;
                    break;
            }
            return null;
        }

        public CongressEvent CurrentlyRunningHelper(List<CongressEvent> Events)
        {
            // never returns "pause"; always returns a valid CongressEvent (the next if no valid one found that is currently running)
            foreach (CongressEvent event_ in Events)
            {
                if (event_.StartDate.Date.Day == DateTime.Now.Date.Day)
                {
                    // 1560 < 1640
                    if (event_.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                    {
                        // it started already or is over already...
                        if ((event_.StartTime.TimeOfDay.Ticks + event_.duration.Ticks) > DateTime.Now.TimeOfDay.Ticks)
                        {
                            // it's running
                            return event_;
                        }
                        else
                        {
                            // it's over
                        }
                    }
                    else
                    {

                    }
                }
            }
            // when we end up here; we obviously did not found anything; so let's give the requesting user the next upcoming event
            foreach (CongressEvent event_ in Events)
            {
                if (event_.StartDate.Date.Day == DateTime.Now.Date.Day)
                {
                    // something found for today
                    if (event_.StartTime.TimeOfDay.Ticks > DateTime.Now.TimeOfDay.Ticks)
                    {
                        return event_;
                    }

                }
            }
            return null;
        }

        public void UpdateThread()
        {
            // here we're doing the updateing work
            while (true)
            {
                CongressEvent current_event = null;
                CongressEvent next_event = null;
                int percentdone;

                #region Saal 1
                current_event = CurrentlyRunningHelper(Saal1);

                next_event = NextRunningHelper(current_event);

                if (current_event == null)
                {
                    SetSaal1RunningText("Pause/n.A.");
                }
                else
                {
                    // check if Current Event already began
                    if (current_event.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                    {
                        // started
                        if (next_event == null)
                        {
                            // nothing comes next
                            SetSaal1UpcomingText("Ende fr heute");
                        }
                        else
                        {
                            SetSaal1UpcomingText(next_event.Title);
                        }

                        SetSaal1RunningText(current_event.Title);

                        // calculate the percent value for the current event
                        percentdone = 100-Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal1ProgressBar(percentdone);
                    }
                    else
                    {
                        // did not start
                        SetSaal1UpcomingText(current_event.Title);
                        SetSaal1RunningText("Pause");

                        // calculate the percent value for the pause...
                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal1ProgressBar(percentdone);

                    }
                }

                #endregion

                #region Saal 2
                current_event = CurrentlyRunningHelper(Saal2);

                next_event = NextRunningHelper(current_event);

                if (current_event == null)
                {
                    SetSaal2RunningText("Ende fr heute");
                }
                else
                {
                    // check if Current Event already began
                    if (current_event.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                    {
                        // started
                        if (next_event == null)
                        {
                            // nothing comes next
                            SetSaal2UpcomingText("Ende fr heute");
                        }
                        else
                        {
                            SetSaal2UpcomingText(next_event.Title);
                        }

                        SetSaal2RunningText(current_event.Title);
                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal2ProgressBar(percentdone);

                    }
                    else
                    {
                        // did not start
                        SetSaal2UpcomingText(current_event.Title);
                        SetSaal2RunningText("Pause");

                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal2ProgressBar(percentdone);

                    }
                }

                #endregion

                #region Saal 3
                current_event = CurrentlyRunningHelper(Saal3);

                next_event = NextRunningHelper(current_event);

                if (current_event == null)
                {
                    SetSaal3RunningText("Ende fr heute");
                }
                else
                {
                    // check if Current Event already began
                    if (current_event.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                    {
                        // started
                        if (next_event == null)
                        {
                            // nothing comes next
                            SetSaal3UpcomingText("Ende fr heute");
                        }
                        else
                        {
                            SetSaal3UpcomingText(next_event.Title);
                        }

                        SetSaal3RunningText(current_event.Title);
                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal3ProgressBar(percentdone);

                    }
                    else
                    {
                        // did not start
                        SetSaal3UpcomingText(current_event.Title);
                        SetSaal3RunningText("Pause");

                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal3ProgressBar(percentdone);

                    }
                }

                #endregion

                #region Saal 4
                current_event = CurrentlyRunningHelper(Saal4);

                next_event = NextRunningHelper(current_event);

                if (current_event == null)
                {
                    SetSaal4RunningText("Ende fr heute");
                }
                else
                {
                    // check if Current Event already began
                    if (current_event.StartTime.TimeOfDay.Ticks < DateTime.Now.TimeOfDay.Ticks)
                    {
                        // started
                        if (next_event == null)
                        {
                            // nothing comes next
                            SetSaal4UpcomingText("Ende fr heute");
                        }
                        else
                        {
                            SetSaal4UpcomingText(next_event.Title);
                        }

                        SetSaal4RunningText(current_event.Title);
                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal4ProgressBar(percentdone);

                    }
                    else
                    {
                        // did not start
                        SetSaal4UpcomingText(current_event.Title);
                        SetSaal4RunningText("Pause");

                        percentdone = 100 - Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);
                        SetSaal4ProgressBar(percentdone);

                    }
                }

                #endregion


                #region old
                /*
                #region Saal 1
                try
                {
                    if ((Saal1.First.Value.StartTime.TimeOfDay.Ticks+Saal1.First.Value.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                    {
                        current_event = Saal1.First.Value;
                        next_event = Saal1.First.Next.Value;
                    }
                    else
                    {
                        Saal1.RemoveFirst();
                        current_event = Saal1.First.Value;
                        next_event = Saal1.First.Next.Value;
                    }

                }
                catch (Exception)
                {
                }

                if (current_event != null)
                {
                    percentdone = Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);

                    if ((percentdone >= 0) && (percentdone < 101))
                    {
                        SetSaal1ProgressBar(100 - percentdone);
                        SetSaal1RunningText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            percentdone = Convert.ToInt32((double)(((next_event.StartTime.TimeOfDay.Ticks + next_event.duration.Ticks)) / (double)(DateTime.Now.TimeOfDay.Ticks)) * 100);
                        }
                        SetSaal1RunningText("Pause");
                        SetSaal1ProgressBar(percentdone);
                    }

                    if (percentdone > 100)
                    {
                        SetSaal1ProgressBar(100 - (percentdone - 100));
                        SetSaal1RunningText("Pause");
                        SetSaal1UpcomingText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            SetSaal1UpcomingText(next_event.Title);
                        }
                    }

                }
                else
                    SetSaal1RunningText("Pause");
                #endregion

                #region Saal 2
                try
                {
                    if ((Saal2.First.Value.StartTime.TimeOfDay.Ticks + Saal2.First.Value.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                    {
                        current_event = Saal2.First.Value;
                        next_event = Saal2.First.Next.Value;
                    }
                    else
                    {
                        Saal2.RemoveFirst();
                        current_event = Saal2.First.Value;
                        next_event = Saal2.First.Next.Value;
                    }

                }
                catch (Exception)
                {
                }

                if (current_event != null)
                {
                    percentdone = Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);

                    if ((percentdone >= 0) && (percentdone < 101))
                    {
                        SetSaal2ProgressBar(100 - percentdone);
                        SetSaal2RunningText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            percentdone = Convert.ToInt32((double)(((next_event.StartTime.TimeOfDay.Ticks + next_event.duration.Ticks)) / (double)(DateTime.Now.TimeOfDay.Ticks)) * 100);
                        }
                        SetSaal2RunningText("Pause");
                        SetSaal2ProgressBar(percentdone);
                    }

                    if (percentdone > 100)
                    {
                        SetSaal2ProgressBar(100 - (percentdone - 100));
                        SetSaal2RunningText("Pause");
                        SetSaal2UpcomingText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            SetSaal2UpcomingText(next_event.Title);
                        }
                    }

                }
                else
                    SetSaal2RunningText("Pause");
                #endregion

                #region Saal 3
                try
                {
                    if ((Saal3.First.Value.StartTime.TimeOfDay.Ticks + Saal3.First.Value.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                    {
                        current_event = Saal3.First.Value;
                        next_event = Saal3.First.Next.Value;
                    }
                    else
                    {
                        Saal3.RemoveFirst();
                        current_event = Saal3.First.Value;
                        next_event = Saal3.First.Next.Value;
                    }

                }
                catch (Exception)
                {
                }

                if (current_event != null)
                {
                    percentdone = Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);

                    if ((percentdone >= 0) && (percentdone < 101))
                    {
                        SetSaal3ProgressBar(100 - percentdone);
                        SetSaal3RunningText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            percentdone = Convert.ToInt32((double)(((next_event.StartTime.TimeOfDay.Ticks + next_event.duration.Ticks)) / (double)(DateTime.Now.TimeOfDay.Ticks)) * 100);
                        }
                        SetSaal3RunningText("Pause");
                        SetSaal3ProgressBar(percentdone);
                    }
                    if (percentdone > 100)
                    {
                        SetSaal3ProgressBar(100 - (percentdone - 100));
                        SetSaal3RunningText("Pause");
                        SetSaal3UpcomingText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            SetSaal3UpcomingText(next_event.Title);
                        }
                    }


                }
                else
                    SetSaal3RunningText("Pause");

                #endregion

                #region Saal 4
                try
                {
                    if ((Saal4.First.Value.StartTime.TimeOfDay.Ticks + Saal4.First.Value.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                    {
                        current_event = Saal4.First.Value;
                        next_event = Saal4.First.Next.Value;
                    }
                    else
                    {
                        Saal4.RemoveFirst();
                        current_event = Saal4.First.Value;
                        next_event = Saal4.First.Next.Value;
                    }

                }
                catch (Exception)
                {
                }

                if (current_event != null)
                {
                    percentdone = Convert.ToInt32((double)(((current_event.StartTime.TimeOfDay.Ticks + current_event.duration.Ticks) - DateTime.Now.TimeOfDay.Ticks) / (double)current_event.duration.Ticks) * 100);

                    if ((percentdone >= 0) && (percentdone < 101))
                    {
                        SetSaal4ProgressBar(100 - percentdone);
                        SetSaal4RunningText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            percentdone = Convert.ToInt32((double)(((next_event.StartTime.TimeOfDay.Ticks + next_event.duration.Ticks)) / (double)(DateTime.Now.TimeOfDay.Ticks)) * 100);
                        }
                        SetSaal4RunningText("Pause");
                        SetSaal4ProgressBar(percentdone);
                    }

                    if (percentdone > 100)
                    {
                        SetSaal4ProgressBar(100 - (percentdone - 100));
                        SetSaal4RunningText("Pause");
                        SetSaal4UpcomingText(current_event.Title);
                    }
                    else
                    {
                        if (next_event != null)
                        {
                            SetSaal4UpcomingText(next_event.Title);
                        }
                    }

                }
                else
                    SetSaal4RunningText("Pause");
                #endregion
                */
                #endregion
                Thread.Sleep(1000);
            }
        }
        private void comingup_FormClosed(object sender, FormClosedEventArgs e)
        {
            render_thread.Abort();
        }
    }
}