using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace CreateNewName
{
    #region Congress Event Data definition
    /// <summary>
    /// holds the data of one particular category
    /// </summary>
    public class CongressEvent
    {
        public Int32 Id;
        public Int32 DayIndex;
        public DateTime StartDate;
        public DateTime StartTime;
        public TimeSpan duration;
        public String Room;
        public String Title;
        public String Subtitle;
        public String track;
        public String tag;
        public String language;
        public String abstract_text;
        public String description;

        public List<String> Persons;

        public List<String> Links;

        public CongressEvent()
        {
            Persons = new List<String>();
            Links = new List<String>();
        }
    }
    #endregion

    class Program
    {
        public static string Speakers(CongressEvent event_)
        {
            String Speakers_ = "";
              
            int count = 0;

            foreach (String speaker in event_.Persons)
            {
                count++;

                if (count == 1)
                    Speakers_ = speaker;
                else
                    Speakers_ = Speakers_ + ", " + speaker;
            }
            return Speakers_;
        }


        public static List<CongressEvent> Events = new List<CongressEvent>();
        static void Main(string[] args)
        {
            #region Load Conference XML
            XmlTextReader reader = new XmlTextReader("schedule.en.xml");

            CongressEvent currentEvent = new CongressEvent();

            DateTime currentDay = DateTime.Now;
            bool addoneday = false;
            bool raushier = false;

            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.EndElement:
                        switch (reader.Name)
                        {
                            case "conference":
                                raushier = true;
                                break;
                        }
                        break;
                }
                if (raushier) break;
            }


            while (reader.Read())
            {
                switch (reader.NodeType)
                {
                    case XmlNodeType.Element: // Der Knoten ist ein Event
                        switch (reader.Name)
                        {
                            #region Nodes
                            case "day":
                                DateTime.TryParse(reader["date"], out currentDay);
                                //currentDay = DateTime.Now.Date;
                                break;
                            case "event":
                                currentEvent = new CongressEvent();
                                currentEvent.Id = Convert.ToInt32(reader["id"]);
                                currentEvent.StartDate = currentDay;
                                break;
                            case "start":
                                reader.Read();
                                DateTime.TryParse(reader.Value, out currentEvent.StartTime);
                                if (currentEvent.StartTime.Hour == 0)
                                {
                                    addoneday = true;
                                }
                                break;
                            case "duration":
                                reader.Read();
                                TimeSpan.TryParse(reader.Value, out currentEvent.duration);
                                break;
                            case "room":
                                reader.Read();
                                currentEvent.Room = reader.Value;
                                break;
                            case "tag":
                                reader.Read();
                                currentEvent.tag = reader.Value;
                                break;
                            case "title":
                                reader.Read();
                                currentEvent.Title = reader.Value;
                                break;
                            case "subtitle":
                                reader.Read();
                                currentEvent.Subtitle = reader.Value;
                                break;
                            case "person":
                                reader.Read();
                                currentEvent.Persons.Add(reader.Value);
                                break;
                            case "track":
                                reader.Read();
                                currentEvent.track = reader.Value;
                                break;
                            case "language":
                                reader.Read();
                                currentEvent.language = reader.Value;
                                break;
                            #endregion
                        }
                        break;
                    case XmlNodeType.Text: //Anzeigen des Textes in jedem Element.
                        //Console.WriteLine(reader.Value);
                        break;
                    case XmlNodeType.EndElement: //Anzeigen des Endes des Elements.
                        switch (reader.Name)
                        {
                            case "event":
                                if (addoneday)
                                {
                                    currentEvent.StartDate = currentEvent.StartDate.AddDays(1);
                                    addoneday = false;
                                }
                                    Events.Add(currentEvent);
                                /*
                                if (currentEvent.StartDate.Ticks >= DateTime.Now.Date.Ticks)
                                {
                                    if ((currentEvent.StartTime.TimeOfDay.Ticks + currentEvent.duration.Ticks) >= DateTime.Now.TimeOfDay.Ticks)
                                    {
                                    }
                                }*/
                                //CongressEvents.Add(currentEvent);
                                break;
                        }
                        break;
                }
            }
            #endregion

            #region read the template file
            using (StreamReader sr = File.OpenText(args[0]))
            {
                String buffer;

                while ((buffer = sr.ReadLine()) != null)
                {
                    // identify the entry...
                    string ID = buffer.Remove(4);
                    string newFilename = "";
                    CongressEvent event_ = new CongressEvent();

                    foreach (CongressEvent _event in Events)
                    {
                        if (Convert.ToInt32(ID) == _event.Id)
                        {
                            if (_event.language.ToUpper() == "GERMAN")
                            {
                                //newFilename = "23C3-" + _event.Id.ToString() + "-de-" + _event.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("", "ue").Replace("", "Ue").Replace("", "oe").Replace("", "Oe").Replace("", "ae").Replace("", "Ae").Replace("", "ss") + ".m4v";
                                newFilename = "23C3-" + _event.Id.ToString() + "-de-" + _event.tag + ".m4v";
                                event_ = _event;
                            }
                            else
                            {
                                //newFilename = "23C3-" + _event.Id.ToString() + "-en-" + _event.Title.Replace(':', '_').Replace(' ', '_').Replace(',', '_').Replace('.', '_').Replace('?', '_').Replace('/', '_').Replace('\\', '_').Replace('\'', '_').Replace('\"', '_').Replace('&', '_').Replace('>', '_').Replace('<', '_').Replace("", "ue").Replace("", "Ue").Replace("", "oe").Replace("", "Oe").Replace("", "ae").Replace("", "Ae").Replace("", "ss") + ".m4v";
                                newFilename = "23C3-" + _event.Id.ToString() + "-en-" + _event.tag + ".m4v";
                                event_ = _event;
                            }
                        }
                    }
                    if (event_.language.ToUpper() == "GERMAN")
                    {
                        Console.WriteLine("AtomicParsley " + buffer + " -a \"" + Speakers(event_) + "\" --title \"" + event_.Title + "\" --comment \"http://events.ccc.de/congress/2006/Fahrplan/events/"+event_.Id+".de.html\" --copyright \"Licensed to the public under http://creativecommons.org/licenses/by-nc-nd/2.0/de/ verify at http://www.ccc.de/congress/2006/\" --album \"23rd Chaos Communication Congress\" -w \"Chaos Computer Club\" -o Z:\\Step_8_uploading\\" + newFilename);
                    }
                    else
                    {
                        Console.WriteLine("AtomicParsley " + buffer + " -a \"" + Speakers(event_) + "\" --title \"" + event_.Title + "\" --comment \"http://events.ccc.de/congress/2006/Fahrplan/events/" + event_.Id + ".en.html\" --copyright \"Licensed to the public under http://creativecommons.org/licenses/by-nc-nd/2.0/de/ verify at http://www.ccc.de/congress/2006/\" --album \"23rd Chaos Communication Congress\" -w \"Chaos Computer Club\" -o Z:\\Step_8_uploading\\" + newFilename);
                    }
                }
                sr.Close();
            }
            #endregion

        }
    }
}
